#ifndef INC_GTSCROLLBAR_H
#define INC_GTSCROLLBAR_H

#include "gtwidget.h"
#include "gtscroller.h"
#include "gtbutton.h"

/************************************************************************\
*
* GtScrollBar class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/


class GtScrollBar : public GtWidget
{
public:
		/* Standard */
	GtScrollBar(void);
	void Destroy(void);
	sbool Init(char *n,GtManager *p,GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtScrollBar"); }
	sbool IsSubClassOf(char *cn);
		/* Instance checks */
	sbool Manage(void) { return(FALSE); }
		/* Callbacks */
	void AddCB(ulong tag,GtCallB cb,GtUDPtr ud);
	void RemCB(ulong tag,GtCallB cb);
		/* Values */
	inline GtGroup *GetGroup(void) { return(grp); }
	inline GtScroller *GetScroller(void) { return(scr); }
private:
		/* Internal callbacks */
	static int ArrowUp(GtBase *obj,GtCDPtr cd,GtUDPtr ud);
	static int ArrowDown(GtBase *obj,GtCDPtr cd,GtUDPtr ud);
protected:
		/* Instance variables */
	GtGroup *grp;
	GtScroller *scr;
	GtButton *up,*down;
	ulong step;
	ubyte orient;
};

extern GtScrollBar *GtMkScrollBar(char *n,GtManager *p,GtTag *tgs);
extern GtScrollBar *GtMkScrollBar(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTSCROLLBAR_H */
