#ifndef INC_GTWINDOW_H
#define INC_GTWINDOW_H

#include <X11/Xlib.h>

#include "gtdrawable.h"
#include "gtdisplay.h"
#include "gtpixmap.h"
#include "gtcolormap.h"
#include "gtcursor.h"

/************************************************************************\
*
* GtWindow class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

class GtWindow : public GtDrawable
{
public:
		/* Standard */
	GtWindow(void);
	void Destroy(void);
	sbool Init(GtDisplay *d,GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtWindow"); }
	sbool IsSubClassOf(char *cn);
		/* Changes */
	void Map(sbool map);
	inline void Move(int xp,int yp) { XMoveWindow(dsp->XDsp(),win,xp,yp); }
	inline void Resize(int xs,int ys) { XResizeWindow(dsp->XDsp(),win,xs,ys); }
	inline void MoveResize(int xp,int yp,int xs,int ys)
		{ XMoveResizeWindow(dsp->XDsp(),win,xp,yp,xs,ys); }
	inline void Raise(void) { XRaiseWindow(dsp->XDsp(),win); }
	inline void Lower(void) { XLowerWindow(dsp->XDsp(),win); }
		/* Values */
	inline Window XWin(void) { return(win); }
		/* Special */
	inline void Clear(void) { XClearWindow(dsp->XDsp(),win); }
	inline void Clear(int xp,int yp,int xs,int ys)
		{ XClearArea(dsp->XDsp(),win,xp,yp,xs,ys,False); }
	sbool GrabPointer(Time tm,GtTag *tgs);
	sbool GrabPointerV(Time tm,ulong tag,...);
	void UnGrabPointer(Time tm);
protected:
	GtWindow *parent;
	GtPixmap *back,*border;
	GtColormap *cmap;
	GtCursor *cur;
	Window win;
	ulong brpixel,bgpixel;
	sbool rs,nofreex;
};

extern GtWindow *GtMkWindow(GtDisplay *d,GtTag *tgs);
extern GtWindow *GtMkWindow(GtDisplay *d,ulong tag,...);

#endif /* INC_GTWINDOW_H */
